<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Services\RelRoyaltiesEFundoMarketingService;

class RelRoyaltiesEFundoMarketing  {

    protected $utilService;
    protected $RelRoyaltiesEFundoMarketingService;
    
    public function __construct(Utilities\Util $utilService, RelRoyaltiesEFundoMarketingService $RelRoyaltiesEFundoMarketingService) {
        $this->utilService   = $utilService;
        $this->reportService = $RelRoyaltiesEFundoMarketingService;
    }
    
    public function findReport(DTO\Request\Filter $request, DTO\Response $response) {
        $results = [];
        $conditions = $this->utilService->getParamsAsArray($request);
        
        if(isset($conditions['CDFILIAL']) && !empty($conditions['CDFILIAL'])) {
            $result = $this->reportService->fetchReport($conditions);
            $response->addDataSet(new DataSet("vnd0161E_relRoyaltiesEFundoMarketing", $result));
            return $response;
        }
        return $results;
    }
}