<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelVendDiaSemana  {

    protected $RelVendDiaSemanaService;
    protected $utilService;
    
    public function __construct(Services\RelVendDiaSemanaService $RelVendDiaSemanaService, Utilities\Util $utilService) {
        $this->RelVendDiaSemanaService = $RelVendDiaSemanaService;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $result = [];
        $conditions = $this->utilService->getParamsAsArray($request);
        
        if(isset($conditions['CDFILIAL']) && !empty($conditions['CDFILIAL'])) {
            $conditions = $this->buildParams($conditions);
            if($conditions['TIPORELATORIO'] == 'C') {
                $result = $this->RelVendDiaSemanaService->findConsolidado($conditions['CDFILIAL'], $conditions['NRORG'], $conditions['CDLOJA'], $conditions['TCDLOJA'], $conditions['DTVENDAINI'], $conditions['DTVENDAFIN']);
            } else {
                $result = $this->RelVendDiaSemanaService->findAnalitico($conditions['CDFILIAL'], $conditions['NRORG'], $conditions['CDLOJA'], $conditions['TCDLOJA'], $conditions['DTVENDAINI'], $conditions['DTVENDAFIN']);
            }
        }
        
        $response->addDataSet(new DataSet("vnd01601_VendDiaSemConsolidado", $result));
        
        return $response;
    }

    public function buildParams($conditions){
        $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
        
        if(empty($conditions['CDLOJA'])) {
            $conditions['CDLOJA'] = '';
            $conditions['TCDLOJA'] = 'T';
        } else {
            $conditions['CDLOJA'] = implode('_', $conditions['CDLOJA']);
            $conditions['TCDLOJA'] = '';
        }
        
        if(array_key_exists('DTENTRVENDA', $conditions)) {
            $conditions['DTVENDAINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DTVENDAFIN'] = $conditions['DTENTRVENDA'][1];
            unset($conditions['DTENTRVENDA']);
        }
        return $conditions;
    }
    
}
